## freefem++ 4.9+dfsg1

=== 3rdparty/ipopt/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

include Makefile.inc

all-local: Ipopt

MAKEFLAGS += -j1

# Downloading and compiling mumps
# ------------------------------

DIR=$(DOWNLOADFF)/ipopt
DIRPKG=../pkg
SRCDIR=Ipopt-$(VERSION)
PACKAGE=$(DIRPKG)/Ipopt-$(VERSION).tgz
INSTALL=../..
VERSION=3.12.4
# 3.10.2
URL=http://www.coin-or.org/download/source/Ipopt
FHSL=#$(DIRPKG)/ddeps.f $(DIRPKG)/ma27ad.f  $(DIRPKG)/mc19d.f 
WHERE_MUMPSSEQ=$(wildcard ../lib/WHERE.mumpsseq)

ifeq ($(WHERE_MUMPSSEQ),)
LIBMUMPS=-ldmumps_seq -lzmumps_seq  -lmumps_common_seq  -lpord_seq -lmpiseq_seq 
INCMUMPS=/usr/include/mumps_seq
else
LIBMUMPS=-L$(DOWNLOADFF)/lib  -ldmumpsFREEFEM-SEQ -lzmumpsFREEFEM-SEQ -lmumps_commonFREEFEM-SEQ -lpordFREEFEM-SEQ -lmpiseqFREEFEM-SEQ
INCMUMPS=$(DOWNLOADFF)/include/mumps_seq
endif

#/Ipopt-3.10.2.tgz
Ipopt: $(SRCDIR)/FAIRE
#  --enable-static  --disable-shared  

# ALH - 6/1/14 - We need to specify FLIBS explicitely because Ipopt
# fails to guess FLIBS correctly on Windows+Cygwin+Mingw64, see [[file:Makefile.inc.in::FLIBS]]

$(SRCDIR)/FAIT: $(SRCDIR)/tag-tar
#	FFCS - disable dependency tracking like in FFCS itself for MinGW compilation (problem with backslashes, see
#	[[file:../../../../configure.ac::enable_dependency_tracking]])
	cd $(SRCDIR) ; \
	 ./configure --disable-dependency-tracking \
		   --disable-shared --enable-static \
                  --with-mumps='$(LIBMUMPS)' \
	          --without-hsl \
	          --with-mumps-incdir='$(INCMUMPS)' \
	  CXX='$(CXX)' CXXFLAGS='$(CXXFLAGS) -I$(INCMUMPS)' \
	  CC='$(CC)' CFLAGS='$(CFLAGS) -I$(INCMUMPS)' \
	  F77='$(FC)' FFLAGS='$(FCFLAGS)' \
	  FLIBS='$(FLIBS)' \
	  CXXCPP='$(CXXCPP)'  CPP='$(CXXCPP)' MPICC='' MPICXX='' MPIFC='' \
	 --with-blas-lib='$(LIBBLAS)' --with-lapack='$(LIBLAPACK)' --prefix='$(DOWNLOADFF)'
	 -rm -rf ../include/coin
	touch $(SRCDIR)/FAIT	

# FFCS - avoid remaking install every time
install.done: Makefile $(SRCDIR)/FAIT
	$(MAKE)  -C  $(SRCDIR) install	
	touch $@
clean-local::
	-rm *.done

# FFCS - install and WHERE need to be sequential
WHERE.done: install.done Makefile
	echo ipopt LD -L@DIR@/lib   -lipopt   >$(SRCDIR)/$(INSTALL)/lib/WHERE.Ipopt;
	echo ipopt INCLUDE -I@DIR@/include  >> $(SRCDIR)/$(INSTALL)/lib/WHERE.Ipopt ;
	touch $@

Makefile.inc:
	../../config.status  --file="Makefile.inc:Makefile.inc.in"

# FFCS - install and WHERE need to be sequential
$(SRCDIR)/FAIRE: install.done WHERE.done
	touch $@


$(SRCDIR)/$(INSTALL): $(SRCDIR)/tag-tar

$(SRCDIR)/tag-tar:$(PACKAGE) $(FHSL) 
	tar xzf $(PACKAGE)
#	patch -p0 <patch-IpBlas
	touch $(SRCDIR)/tag-tar

$(PACKAGE):
	../getall -o Ipopt -a

clean-local::
	rm -rf  $(SRCDIR)  *~ Makefile.inc

clean: clean-local
	-rm -rf ../include/coin
	-rm ../lib/libipopt* ../lib/liblcoinhsl* 
#FH	-rm $(PACKAGE)

.PHONY:$(SRCDIR)/$(INSTALL)
#.NOTPARALLEL:$(SRCDIR)/$(INSTALL)

=== 3rdparty/mmg/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

all-local: mmg

include ff-flags

# Downloading and compiling mmg
# -------------------------------
#
DIRPKG= ../pkg
SRCDIR= .
PACKAGE=$(DIRPKG)/mmg.zip
INSTALL=.
mmg_VERSION=

mmg:WHERE.done

ifeq ($(WIN32DLLTARGET),)
CMAKE_GENERATOR := 
else
CMAKE_GENERATOR := -G "MSYS Makefiles"
endif

FAIT.done:tag-tar
	-mkdir build
	cd build && cmake ../mmg-sources \
	-DCMAKE_C_COMPILER=$(CC) \
	-DCMAKE_C_FLAGS="$(CFLAGS) -fPIC" \
	-DCMAKE_CXX_COMPILER=$(CXX) \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CXX11FLAGS) -fPIC" \
	-DM_LIB="-lm" -DUSE_ELAS=OFF -DUSE_VTK=OFF \
	-DSCOTCH_DIR=$(scotch_dir) \
	-DCMAKE_BUILD_TYPE=Release $(CMAKE_GENERATOR) && $(MAKE)
	touch FAIT.done

install.done:FAIT.done
	cp -r build/include/mmg ../include/mmg
	cp build/lib/libmmg.a ../lib
	touch $@

mmg:$(PACKAGE)

install:install.done WHERE.done

WHERE.done: install.done
	echo mmg LD -L@DIR@/lib -lmmg >../lib/WHERE.mmg ;
	echo mmg INCLUDE -I@DIR@/include/>> ../lib/WHERE.mmg ;
	echo build WHERE ./lib/WHERE.mmg ;
	touch $@
clean::
	-rm WHERE.done

FAIRE: FAIT.done install.done

tag-tar: $(PACKAGE)
	-rm -rf mmg-*
	unzip -q $(PACKAGE) && mv mmg-* mmg-sources
#	patch -p1 <patch-mmg 
	touch tag-tar

$(PACKAGE): FORCE
	../getall -o mmg -a

FORCE:

clean::
	-rm ff-flags *.done 
	-rm FAIT* 
	-rm -rf mmg-* build
	-rm flags-* tag-tar*
	-rm -rf ../include/mmg
	-rm ../lib/libmmg.a

ff-flags: ../Makefile Makefile ../getall
	../getall -o mmg -a
	-cp -f ff-flags ff-flags.old
	grep 'abs_top_builddir *=' ../Makefile > ff-flags
	grep 'CC *=' ../Makefile >> ff-flags
	grep 'CFLAGS *=' ../Makefile >> ff-flags
	grep 'CXX *=' ../Makefile >> ff-flags
	grep 'CXXFLAGS *=' ../Makefile >> ff-flags
	grep 'CXX11FLAGS *=' ../Makefile >> ff-flags
	grep 'LDFLAGS *=' ../Makefile >> ff-flags
	grep 'AR *=' ../Makefile >> ff-flags
	grep 'ARFLAGS *=' ../Makefile >> ff-flags
	grep 'RANLIB *=' ../Makefile >> ff-flags
	grep 'WGET *=' ../Makefile >> ff-flags
	grep 'STD_LIBS *=' ../Makefile >> ff-flags
	grep 'CNOFLAGS *=' ../Makefile >> ff-flags
	grep 'WIN32DLLTARGET *=' ../Makefile >> ff-flags
	grep 'FF_prefix_petsc_real *=' ../Makefile >> ff-flags
	-awk '/^scotch LD /&&/petsc/ {print "scotch_dir=$$(FF_prefix_petsc_real)" }' ../../plugin/seq/WHERE_LIBRARY-config >> ff-flags
	-awk '/^scotch LD /{print "scotch_dir=../../../3rdparty/" }' ../lib/WHERE.scotch >> ff-flags
	../../bin/ff-md5 $(PACKAGE) >> ff-flags	
	if diff -q ff-flags ff-flags.old ; then echo No Modif skip compile of mmg ; else touch -c tag-tar; fi

.PHONY:$(SRCDIR)/$(INSTALL)

=== 3rdparty/mumps/Makefile ===
# ======================================================================
# Laboratoire Jacques-Louis Lions
# Université Pierre et Marie Curie-Paris6, UMR 7598, Paris, F-75005 France
# http://www.ljll.math.upmc.fr/lehyaric
# ======================================================================
# This file is part of Freefem++
# 
# Freefem++ is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
# 
# Freefem++ is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General Public
# License along with Freefem++; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
# ======================================================================
# headeralh default=0 freefem make multipleauthors start=19/03/10 upmc

include Makefile.inc

all-local: mumps

# Downloading and compiling mumps
# -------------------------------

DIRPKG=../pkg
SRCDIR=MUMPS_$(VERSION)
PACKAGE1=$(DIRPKG)/MUMPS_$(VERSION).tar.gz
VERSION=5.0.2

mumps:../lib/WHERE.mumps

$(SRCDIR)/FAIT: $(SRCDIR)/tag-tar
	cp Makefile.inc $(SRCDIR)
#
# ALH - 'd' and 'z' versions need to be made sequentially
#
	cd $(SRCDIR);make d
	cd $(SRCDIR);make z
	touch $@

# ALH - WHERE was not built properly during a full compile from a clean source. This goal has been rewritten to solve
# this issue.

../lib/WHERE.mumps:install.done
	echo mumps LD -L@DIR@/lib   -ldmumpsFREEFEM -lzmumpsFREEFEM  -lmumps_commonFREEFEM -lpordFREEFEM $(LIBSPTHREAD)  > $@
	echo mumps INCLUDE -I@DIR@/include  >> $@

install.done:$(SRCDIR)/FAIT
	-mkdir -p ../include/libseq
	cp $(SRCDIR)/include/*.h ../include/
	cp $(SRCDIR)/libseq/*.h  ../include/libseq
	-mkdir -p ../lib
	cp $(SRCDIR)/lib/*.a ../lib/
	cp $(SRCDIR)/libseq/libmpiseqFREEFEM.a ../lib/
	touch $@

FAIRE-$(VERSION):WHERE
	touch FAIRE-$(VERSION)

# ALH - "make d" and "make z" need to be done sequentially
$(SRCDIR)/FAIT:$(SRCDIR)/tag-tar Makefile.inc
	cp Makefile.inc $(SRCDIR)
	cd $(SRCDIR) && $(MAKE) d
	cd $(SRCDIR) && $(MAKE) z
	touch $@

Makefile.inc:../../config.status Makefile Makefile-mumps-$(VERSION).inc
	../../config.status --file="Makefile.inc:Makefile-mumps-$(VERSION).inc"

$(SRCDIR)/tag-tar:$(PACKAGE1)
	tar xzf $(PACKAGE1)
	#patch -d MUMPS_$(VERSION) -p 1 < MUMPS_$(VERSION).patch
	touch $(SRCDIR)/tag-tar

clean:clean-local
clean-local:
#FH	-cd $(SRCDIR) &&  $(MAKE) clean -C $(SRCDIR) 
	-rm Makefile.inc FAIRE* ../lib/WHERE.mumps
	-rm -rf ../include/*mumps*
	-rm -rf ../lib/lib*mumpsFREEFEM* ../lib/libpordFREEFEM.a ../lib/libmpiseqFREEFEM.a 
	-rm -rf $(SRCDIR)
#	-rm $(PACKAGE1)
	-rm config.log *.done

# Local Variables:
# mode:makefile
# ispell-local-dictionary:"british"
# coding:utf-8
# End:

=== examples/bug/CMakeLists.txt ===
FILE(GLOB EDP_FILES *.edp)
FOREACH(EDP_FILE ${EDP_FILES})
  GET_FILENAME_COMPONENT(FILENAME ${EDP_FILE} NAME_WE)
  ADD_TEST(NAME ${FILENAME} COMMAND "${CMAKE_BINARY_DIR}/src/FreeFem++" ${EDP_FILE}
                            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/examples/bug)
ENDFOREACH(EDP_FILE)

=== examples/hpddm/CMakeLists.txt ===
FILE(GLOB EDP_FILES *.edp)
FOREACH(EDP_FILE ${EDP_FILES})
  GET_FILENAME_COMPONENT(FILENAME ${EDP_FILE} NAME_WE)
  ADD_TEST(NAME ${FILENAME} COMMAND "${CMAKE_BINARY_DIR}/src/FreeFem++" ${EDP_FILE})
ENDFOREACH(EDP_FILE)

=== debian/changelog ===
freefem++ (4.9+dfsg1-2build1) jammy; urgency=medium

  * No-change rebuild against libgsl27

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 07 Dec 2021 17:30:06 +0000

freefem++ (4.9+dfsg1-2) unstable; urgency=medium

  * Fix blhc false positive with ff-c++ 
  * Fix invalid uploader (Closes: #992381)
  * Configure with --enable-generic to fix baseline violation
    (Closes: #924009)

 -- Francois Mazen <francois@mzf.fr>  Tue, 17 Aug 2021 22:45:22 +0200

freefem++ (4.9+dfsg1-1) unstable; urgency=medium

  * New upstream version (Closes: #969022)
  * Bump standard version to 4.5.1
  * Set debhelper-compat to 13
  * Set Rules-Requires-Root to no
  * Remove trailing whitespaces
  * Set secure url in copyright file
  * Remove obsolete patches
  * Fix native encoding of some files
  * Fix missing hardening flags
  * Add man page for ffmaster
  * Fix file path in ffmaster
  * Add upstream metadata
  * Add missing dependency (unzip)
  * Fix config.h PACKAGE_NAME collision by using AX_PREFIX_CONFIG_H
  * Add auto package tests
  * Add debian/clean file
  * Add Francois Mazen as uploader

 -- Francois Mazen <francois@mzf.fr>  Fri, 21 May 2021 22:23:38 +0200

freefem++ (3.61.1+dfsg1-6) unstable; urgency=high

  * Team upload.
  * Fix FTBFS with GCC-10 (Closes: #957233)

 -- Francois Mazen <francois@mzf.fr>  Thu, 13 May 2021 14:06:33 +0200

freefem++ (3.61.1+dfsg1-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with gsl 2.6 (Closes: #960010)

 -- Stefano Rivera <stefanor@debian.org>  Sun, 17 May 2020 13:41:04 -0700

=== debian/control ===
Source: freefem++
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>,
           Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>,
           Francois Mazen <francois@mzf.fr>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libsuperlu-dev,
               gawk,
               gfortran,
               rdfind,
               symlinks,
               libhdf5-dev,
               flex,
               bison,
               libxt-dev,
               libxext-dev,
               libxxf86vm-dev,
               libxpm-dev,
               libmumps-scotch-dev,
               libmumps-ptscotch-dev,
               libfltk1.3-dev,
               freeglut3-dev,
               ghostscript,
               imagemagick,
               texlive,
               texlive-extra-utils,
               texlive-latex-extra,
               texlive-font-utils,
               libfftw3-dev,
               libgsl-dev,
               libhypre-dev,
               libarpack2-dev,
               libsuitesparse-dev,
               libmumps-dev,
               libscalapack-mpi-dev (>= 2),
               libscotch-dev,
               libptscotch-dev,
               libmetis-dev,
               libmumps-seq-dev,
               libnlopt-dev,
               coinor-libipopt-dev,
               libgmm++-dev,
               libtet1.5-dev,
               libpetsc-real-dev,
               libpetsc-complex-dev,
               unzip,
               autoconf-archive
# libmmg3dlib4.0-4.0-dev, freeyams, mshmet, mshint,
# libparms2-dev, libitsol-dev,
# libhips-dev, libpastix-dev,
# libsuperlu-dist-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/science-team/freefempp
Vcs-Git: https://salsa.debian.org/science-team/freefempp.git
Homepage: http://www.freefem.org/ff++/
Rules-Requires-Root: no

Package: freefem++
Architecture: any
Section: math
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Provides the binaries of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the executables of FreeFem++.

Package: libfreefem++
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Provides the shared libraries of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the shared libraries of FreeFem++.

Package: libfreefem++-dev
Architecture: any
Section: libdevel
Depends: libfreefem++,
         ${shlibs:Depends},
         ${misc:Depends}
Description: Provides the development files of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the development files of FreeFem++.

Package: freefem++-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Provides the documentation of the FreeFem++ FE suite
 FreeFem++ is an implementation of a language dedicated to the finite
 element method. It enables you to solve Partial Differential
 Equations (PDE) easily.
 .
 Problems involving PDE from several branches of physics such as
 fluid-structure interactions require interpolations of data on
 several meshes and their manipulation within one program. FreeFem++
 includes a fast quadtree-based interpolation algorithm and a language
 for the manipulation of these data on multiple meshes. It contains
 also a powerful mesh generation and adaption tool integrated
 seamlessly in FreeFem++ called bamg.
 .
 FreeFem++ is written in C++ and the FreeFem++ language is a C++ idiom
 allowing for a smooth learning curve.
 .
 This package contains the documentation files of FreeFem++.

=== debian/tests/control ===
Tests: smoke
Depends: freefem++, expect
Restrictions: superficial

Tests: run-func-example
Depends: freefem++, freefem++-doc, expect

Tests: build-and-run-lib
Depends: libfreefem++-dev, freefem++, build-essential

## freefem++ 4.11+dfsg1

=== examples/CMakeLists.txt ===

ADD_SUBDIRECTORY(misc)
ADD_SUBDIRECTORY(3d)
ADD_SUBDIRECTORY(3dSurf)
ADD_SUBDIRECTORY(examples)
ADD_SUBDIRECTORY(eigen)
#ADD_SUBDIRECTORY(plugin)
ADD_SUBDIRECTORY(mpi)
ADD_SUBDIRECTORY(other)
ADD_SUBDIRECTORY(tutorial)
ADD_SUBDIRECTORY(ffddm)

=== 3rdparty/f2c/Makefile ===

DIRPKG=../pkg
LISTINST=  ../bin/f2c ../bin/fort77 ../include/f2c.h ../lib/libf2c.a
DIRINSTALL=/usr/local
F2C_TAR=$(DIRPKG)/f2c.tar
all:compile

$(F2C_TAR):
	mkdir -p $(DIRPKG)
	$(WGET) # wget --passive-ftp ftp://netlib.bell-labs.com/netlib/f2c.tar
	curl http://netlib.sandia.gov/cgi-bin/netlib/netlibfiles.tar?filename=netlib/f2c -o "$(DIRPKG)/f2c.tar"
f2c:$(F2C_TAR) f2c.h-int
	tar xvf $(F2C_TAR)
	gunzip -rf f2c/*
	gunzip -rf f2c/*/*
	cd f2c;unzip -d libf2c  libf2c.zip
	for i in `find . -name f2c.h`; do cp f2c.h-int $$i; done

f2c/libf2c/makefile: Makefile
	egrep -v 'ld -r|mv [$$]' <f2c/libf2c/makefile.u >f2c/libf2c/makefile

compile:f2c f2c/libf2c/makefile
	cd f2c/src; make -f makefile.u f2c
	cd f2c/libf2c; make 

compile-10.4:f2c Makefile-MacOs
	cd f2c/src; make -f makefile.u f2c
	cd f2c/libf2c; make -f ../../Makefile-MacOs OS=10.4 
compile-10.5:f2c Makefile-MacOs
	cd f2c/src; make -f makefile.u f2c 
	cd f2c/libf2c; make -f ../../Makefile-MacOs OS=10.5
compile-10.6:f2c Makefile-MacOs
	cd f2c/src; make -f makefile.u f2c 
	cd f2c/libf2c; make -f ../../Makefile-MacOs OS=10.6


install:  ../lib ../include ../bin ../bin/fort77 ../bin/mpifort77
	-mkdir ../bin
	cp f2c/src/f2c ../bin/.
	cp f2c/src/f2c.h ../include
	cp f2c/libf2c/libf2c.a ../lib
	../bin/fort77 tt.f
	rm a.out

install-10.4: compile-10.4
	sudo make install-sudo
	make install
install-10.5: compile-10.5
	sudo make install-sudo
	make install
install-10.6: compile-10.6
	sudo make install-sudo
	make install
install-sudo: $(DIRINSTALL)/bin/fort77 $(DIRINSTALL)/bin/mpifort77
	mkdir -p $(DIRINSTALL)/bin $(DIRINSTALL)/include $(DIRINSTALL)/lib
	cp f2c/src/f2c $(DIRINSTALL)/bin; 
	cp f2c/src/f2c.h $(DIRINSTALL)/include; 
	cp f2c/libf2c/libf2c.a $(DIRINSTALL)/lib 	 
	$(DIRINSTALL)/bin/fort77 tt.f	
	rm a.out



../bin/fort77: fort77.sed Makefile
	dd="`pwd`/.." ; \
	sed -e "s;@CC@;$(CC);"g \
	-e "s;@INC@;-I$$dd/include;g" \
         -e "s;@LLIBDIR@;-L$$dd/lib;g" \
         -e "s;@f2c@;$$dd/bin/f2c;g"  < fort77.sed >../bin/fort77
	chmod a+x ../bin/fort77
../bin/mpifort77: fort77.sed Makefile
	dd="`pwd`/.." ; \
	sed -e "s;@CC@;mpicc;"g \
	-e "s;@INC@;-I$$dd/include;g" \
         -e "s;@LLIBDIR@;-L$$dd/lib;g" \
         -e "s;@f2c@;$$dd/bin/f2c;g"  < fort77.sed >../bin/fort77
	chmod a+x ../bin/fort77

$(DIRINSTALL)/bin/fort77: fort77.sed Makefile
	dd="$(DIRINSTALL)/" ; \
	sed -e "s;@CC@;$(CC);"g \
	-e "s;@INC@;-I$$dd/include;g" \
         -e "s;@LLIBDIR@;-L$$dd/lib;g" \
         -e "s;@f2c@;$$dd/bin/f2c;g"  < fort77.sed >$(DIRINSTALL)/bin/fort77
	chmod a+x $(DIRINSTALL)/bin/fort77
$(DIRINSTALL)/bin/mpifort77: fort77.sed Makefile
	dd="$(DIRINSTALL)/" ; \
	sed -e "s;@CC@;mpicc;"g \
	-e "s;@INC@;-I$$dd/include;g" \
         -e "s;@LLIBDIR@;-L$$dd/lib;g" \
         -e "s;@f2c@;$$dd/bin/f2c;g"  < fort77.sed >$(DIRINSTALL)/bin/fort77
	chmod a+x $(DIRINSTALL)/bin/fort77


../bin:	
	mkdir ../bin
../lib:	
	mkdir ../lib
../include:	
	mkdir ../include
clean-local:
	-rm -rf  f2c *~  a.out
clean:clean-local

veryclean: clean 
	-rm $(LISTINST) $(F2C_TAR)

=== 3rdparty/ff-petsc/Makefile ===
# ======================================================================
# Laboratoire Jacques-Louis Lions
# Université Pierre et Marie Curie-Paris6, UMR 7598, Paris, F-75005 France
# http://www.ljll.math.upmc.fr/lehyaric
# ======================================================================
# This file is part of Freefem++
#
# Freefem++ is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation; either version 2.1 of
# the License, or (at your option) any later version.
#
# Freefem++ is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with Freefem++; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
# ======================================================================
# headeralh default=0 freefem make multipleauthors start=19/03/10 upmc

include Makefile.inc
mkfile_path := $(abspath $(lastword $(MAKEFILE_LIST)))
dir3rdparty := $(abspath $(dir $(mkfile_path))/..)

DIR_INSTALL_REAL:=$(FF_prefix_petsc)/r
DIR_INSTALL_COMPLEX:=$(FF_prefix_petsc)/c

W_SUDO:=$(SHELL mkdir -p "$(DESTDIR)$(FF_prefix_petsc)" && test -w "$(DESTDIR)$(FF_prefix_petsc) || echo sudo)
ifeq ($(COMPILE_OPENBLAS),openblas)
PETSC_OPENBLAS := --download-f2cblaslapack
PETSC_OPENBLAS_C := --with-blaslapack-dir=$(DIR_INSTALL_REAL)
else
PETSC_OPENBLAS = --with-blaslapack-include='$(shell echo $(BLASINC) | sed "s/-I//g")' \
		--with-blaslapack-lib='$(BLAS_LAPACK_LIBS)'
PETSC_OPENBLAS_C = $(PETSC_OPENBLAS)
endif
PETSC_DOWNLOAD_C := --with-metis-dir=$(DIR_INSTALL_REAL) \
		--with-ptscotch-dir=$(DIR_INSTALL_REAL) \
		--with-mmg-dir=$(DIR_INSTALL_REAL) \
		--with-parmmg-dir=$(DIR_INSTALL_REAL) \
		--with-superlu-dir=$(DIR_INSTALL_REAL) \
		--with-suitesparse-dir=$(DIR_INSTALL_REAL) \
		--with-parmetis-dir=$(DIR_INSTALL_REAL) \
		--with-tetgen-dir=$(DIR_INSTALL_REAL)
ifeq ($(PETSC_PKG),yes)
pkg_dir=$(abspath $(dir $(mkfile_path))/pkg)
PETSC_DOWNLOAD := --download-scalapack=$(pkg_dir)/pkg-scalapack.tar.gz \
		--download-metis=$(pkg_dir)/pkg-metis.tar.gz \
		--download-ptscotch=$(pkg_dir)/scotch-v6.0.9.tar.gz \
		--download-mumps=$(pkg_dir)/pkg-mumps.tar.gz \
		--download-hypre=$(pkg_dir)/hypre.tar.gz \
		--download-parmetis=$(pkg_dir)/pkg-parmetis.tar.gz \
		--download-superlu=$(pkg_dir)/superlu.tar.gz \
		--download-suitesparse=$(pkg_dir)/SuiteSparse-5.7.1.tar.gz \
		--download-tetgen=$(pkg_dir)/tetgen1.5.1.tar.gz \
		--download-slepc=$(pkg_dir)/slepc.tar.gz \
		--download-hpddm=$(pkg_dir)/hpddm.tar.gz
ifeq ($(FFCMAKE),no)
PETSC_DOWNLOAD := $(PETSC_DOWNLOAD) --download-cmake=$(pkg_dir)/cmake.tar.gz
endif
PETSC_DOWNLOAD_C := $(PETSC_DOWNLOAD_C) --download-slepc=$(pkg_dir)/slepc.tar.gz
ifeq ($(WIN32DLLTARGET),)
PETSC_DOWNLOAD := $(PETSC_DOWNLOAD) --download-hpddm=$(pkg_dir)/hpddm.tar.gz
PETSC_DOWNLOAD_C := $(PETSC_DOWNLOAD_C) --download-hpddm=$(pkg_dir)/hpddm.tar.gz
endif
else
PETSC_DOWNLOAD := --download-metis --download-ptscotch \
		--download-hypre --download-parmetis \
		--download-mmg --download-parmmg \
		--download-superlu --download-suitesparse --download-tetgen \
		--download-slepc --download-hpddm
ifeq ($(FFCMAKE),no)
PETSC_DOWNLOAD := $(PETSC_DOWNLOAD) --download-cmake
endif
PETSC_DOWNLOAD_C := $(PETSC_DOWNLOAD_C) --download-slepc --download-hpddm
endif
ifeq ($(FF_generic_petsc), yes)
FLAGS_MTUNE := -mtune=generic
else
FLAGS_MTUNE := -mtune=native
endif
COMMON_FLAGS := MAKEFLAGS='' --with-debugging=0 COPTFLAGS='-O3 $(FLAGS_MTUNE)' CXXOPTFLAGS='-O3 $(FLAGS_MTUNE)' FOPTFLAGS='-O3 $(FLAGS_MTUNE)' --with-cxx-dialect=C++11 --with-ssl=0 --with-x=0 --with-fortran-bindings=0 --with-cudac=0
ifeq ($(WIN32DLLTARGET),)
##  Not on windows....
ifeq ($(MPICC)$(MPICXX)$(MPIFC),)
PETSC_DOWNLOAD += --with-cc='$(CC)' --with-cxx='$(CXX)' --download-mpich
PETSC_DOWNLOAD_C += --with-mpi-dir=$(DIR_INSTALL_REAL)
ifneq ($(FC),)
PETSC_DOWNLOAD += --with-fc='$(FC)' --download-scalapack --download-mumps --download-slepc-configure-arguments="--download-arpack=https://github.com/prj-/arpack-ng/archive/b64dccb.tar.gz"
PETSC_DOWNLOAD_C += --with-scalapack-dir=$(DIR_INSTALL_REAL) --with-mumps-dir=$(DIR_INSTALL_REAL) # --download-slepc-configure-arguments="--with-arpack-dir=$(DIR_INSTALL_REAL)"
else
COMMON_FLAGS += --with-fc=0
endif
else
COMMON_FLAGS += --with-cc='$(MPICC)' --with-cxx='$(MPICXX)'
ifneq ($(MPIFC),)
COMMON_FLAGS += --with-fc='$(MPIFC)'
PETSC_DOWNLOAD += --download-scalapack --download-mumps --download-slepc-configure-arguments="--download-arpack=https://github.com/prj-/arpack-ng/archive/b64dccb.tar.gz"
PETSC_DOWNLOAD_C += --with-scalapack-dir=$(DIR_INSTALL_REAL) --with-mumps-dir=$(DIR_INSTALL_REAL) # --download-slepc-configure-arguments="--with-arpack-dir=$(DIR_INSTALL_REAL)"
else
COMMON_FLAGS += --with-fc=0
PETSC_DOWNLOAD += --download-superlu_dist
PETSC_DOWNLOAD_C += --with-superlu_dist-dir=$(DIR_INSTALL_REAL)
endif
endif
else
##   On windows....
COMMON_FLAGS += --with-shared-libraries=0 \
	--with-cc='$(CC)' --with-cxx='$(CXX)' \
	CXXFLAGS='-fno-stack-protector' \
	CFLAGS='-fno-stack-protector' \
	FFLAGS='$(FCFLAGS)' \
	--with-mpi-lib='$(MPI_LIB)' \
	--with-mpi-include='$(MPI_INC_DIR)' \
	--with-mpiexec='/C/Program\ Files/Microsoft\ MPI/Bin/mpiexec'
PETSC_DOWNLOAD += '--download-metis-cmake-arguments=-G "MSYS Makefiles"' \
	'--download-parmetis-cmake-arguments=-G "MSYS Makefiles"' \
	'--download-mmg-cmake-arguments=-G "MSYS Makefiles"' \
	'--download-parmmg-cmake-arguments=-DMPI_GUESS_LIBRARY_NAME=MSMPI -G "MSYS Makefiles"' \
	'--download-superlu-cmake-arguments=-G "MSYS Makefiles"' \
	'--download-hypre-configure-arguments=--build=x86_64-linux-gnu --host=x86_64-linux-gnu'
ifneq ($(FC),)
COMMON_FLAGS += --with-fc='$(FC)'
PETSC_DOWNLOAD += --download-scalapack --download-mumps --download-slepc-configure-arguments="--download-arpack=https://github.com/prj-/arpack-ng/archive/6d11c37b2dc9110f3f6a434029353ae1c5112227.tar.gz"
PETSC_DOWNLOAD_C += --with-scalapack-dir=$(DIR_INSTALL_REAL) --with-mumps-dir=$(DIR_INSTALL_REAL) # --download-slepc-configure-arguments="--with-arpack-dir=$(DIR_INSTALL_REAL)"
else
COMMON_FLAGS += --with-fc=0
endif
endif

FLAGS_CONF_PETSC_REAL = $(COMMON_FLAGS) --with-scalar-type=real $(PETSC_OPENBLAS) $(PETSC_DOWNLOAD)
FLAGS_CONF_PETSC_COMPLEX = $(COMMON_FLAGS) --with-scalar-type=complex $(PETSC_OPENBLAS_C) $(PETSC_DOWNLOAD_C)

all-local:
	@echo make ..
	@echo " # To build petsc and slepc do $ make petsc-slepc"
	@echo " # warning you have no write acces in $(DESTDIR)$(FF_prefix_petsc)"
	@echo " # need sudo if '$(W_SUDO)' == 'sudo' .."
	@echo " # run under root "
	@echo " # or create / add access to $(DESTDIR)$(FF_prefix_petsc) "
	@echo " # do for examples:"
	@echo " # PETSC_DOWNLOAD = $(PETSC_DOWNLOAD)"
	@echo "	sudo mkdir $(DESTDIR)$(FF_prefix_petsc)"
	@echo "	sudo chown -R $(LOGNAME) $(DESTDIR)$(FF_prefix_petsc)"
	@echo "	make petsc-slepc "

DIRPKG=../pkg
VERSION=3.15.0
VERSION_SLEPC=3.014.2
PACKAGE=../pkg/petsc-$(VERSION).tar.gz
SRCDIR=petsc-$(VERSION)
MPI_DIR:=$(shell dirname $(MPI_INC_DIR))
W_MPICC:=$(strip $(shell which mpicc))
SUDO_WITH_ENV=$(if $(SUDO), $(SUDO) -E)
ifeq ($(LAPACKLIBS), $(BLASLIBS))
  BLAS_LAPACK_LIBS=$(LAPACKLIBS)
else
  BLAS_LAPACK_LIBS=$(LAPACKLIBS) $(BLASLIBS)
endif

PETSC_DIR:=$(shell pwd)/$(SRCDIR)
petsc-slepc: Makefile.inc dir-install WHERE-all
recompile: recompile-real recompile-complex
recompile-real:
	-rm */tag-make-real
	-rm */tag-install-real
	make WHERE
recompile-complex:
	-rm */tag-make-complex
	-rm */tag-install-complex
	@if [ -n "$(MPI_INCLUDE)" ]; then $(MAKE) -f Makefile.complex WHERE-complex ;\
	else echo " -- No PETSc, no MPI"; fi

dir-install: Makefile.inc
	-$(SUDO) mkdir -p $(DESTDIR)$(DIR_INSTALL_REAL)
	-$(SUDO) chown ${USER} $(DESTDIR)$(DIR_INSTALL_REAL)
	-$(SUDO) mkdir -p $(DESTDIR)$(DIR_INSTALL_COMPLEX)
	-$(SUDO) chown ${USER} $(DESTDIR)$(DIR_INSTALL_COMPLEX)
	@if test -w 	"$(DESTDIR)$(DIR_INSTALL_REAL)" -a -w 	"$(DESTDIR)$(DIR_INSTALL_COMPLEX)" ; then echo "no need of sudo"; echo > do-sudo; \
	else \
	 echo no write access in $(DESTDIR)$(DIR_INSTALL_REAL) and $(DESTDIR)$(DIR_INSTALL_COMPLEX); \
	 echo " do: make petsc-slepc SUDO=sudo "; \
	 echo " or add write access to 2 directory "; \
	 echo sudo >do-sudo; \
	fi
	test -e "$(DESTDIR)$(DIR_INSTALL_REAL)" -a -e "$(DESTDIR)$(DIR_INSTALL_COMPLEX)"
PETSc-real:
	@if [ -n "$(MPI_INCLUDE)" ]; then $(MAKE) WHERE ;\
	else echo " -- No PETSc, no MPI"; fi

PETSc-complex:
	@if [ -n "$(MPI_INCLUDE)" ]; then $(MAKE) -f Makefile.complex WHERE-complex ;\
	else echo " -- No PETSc, no MPI, no PETSc real"; fi

WHERE:../lib/WHERE.PETSc ../lib/WHERE.SLEPc

../lib/WHERE.PETSc:$(SRCDIR)/tag-install-real
	-mkdir ../lib
	echo 'petsc LD -Wl,-rpath,"$(DIR_INSTALL_REAL)/lib" -L"$(DIR_INSTALL_REAL)/lib" -lpetsc' > $@
	echo 'petsc INCLUDE -I"$(DIR_INSTALL_REAL)/include"' >> $@

$(SRCDIR)/tag-make-real:$(SRCDIR)/tag-conf-real
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fr all
	touch $@


$(SRCDIR)/tag-install-real :$(SRCDIR)/tag-make-real
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fr install
	-test -x "`type -p otool`" && make changer
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fr check
	test -e $(DIR_INSTALL_REAL)/include/petsc.h
	test -e $(DIR_INSTALL_REAL)/lib/petsc/conf/petscvariables
	touch $@

Makefile.inc:../../config.status Makefile Makefile-PETSc.inc
	../../config.status --file="Makefile.inc:Makefile-PETSc.inc"

$(SRCDIR)/tag-conf-real:$(SRCDIR)/tag-tar
	cd $(SRCDIR) && ./configure --prefix=$(DIR_INSTALL_REAL) \
		$(FLAGS_CONF_PETSC_REAL) PETSC_ARCH=fr
	test -f $(SRCDIR)/fr/lib/petsc/conf/petscvariables
	touch $@
Make-petsc-download.mk:$(SRCDIR)/tag-install-real 
	test -e $(DIR_INSTALL_REAL)/lib/petsc/conf/petscvariables
	egrep 'PETSC_LIB_BASIC|SCALAPACK_|METIS_|MUMPS_|HPDDM_|TETGEN_|SUPERLU_|MMG_|PTSCOTCH_|SUITESPARSE_' $(DIR_INSTALL_REAL)/lib/petsc/conf/petscvariables | sed 's/-I/ /g'|sort >$@
ifdef 	COMPLEX_CASE
#  version COMPLEX.....
$(SRCDIR)/tag-conf-complex:$(SRCDIR)/tag-tar Make-petsc-download.mk
	cd $(SRCDIR) && ./configure --prefix=$(DIR_INSTALL_COMPLEX) \
		$(FLAGS_CONF_PETSC_COMPLEX) PETSC_ARCH=fc
	test -f $(SRCDIR)/fc/lib/petsc/conf/petscvariables
	touch $@

$(SRCDIR)/tag-make-complex:$(SRCDIR)/tag-conf-complex Make-petsc-download.mk
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fc all
	touch $@

$(SRCDIR)/tag-install-complex :$(SRCDIR)/tag-make-complex
	cd $(SRCDIR) && $(MAKE) PETSC_DIR=$(PETSC_DIR) PETSC_ARCH=fc install
	-test -x "`type -p otool`" && make changec
	test -e $(DIR_INSTALL_COMPLEX)/include/petsc.h
	touch $@
WHERE-complex:../lib/WHERE.PETSc-complex ../lib/WHERE.SLEPc-complex

../lib/WHERE.PETSc-complex:$(SRCDIR)/tag-install-complex
	test -e $(DIR_INSTALL_COMPLEX)/include/petsc.h
	-mkdir ../lib
	echo 'petsccomplex LD -Wl,-rpath,"$(DIR_INSTALL_COMPLEX)/lib" -L"$(DIR_INSTALL_COMPLEX)/lib" -lpetsc' > $@
	echo 'petsccomplex INCLUDE -I"$(DIR_INSTALL_COMPLEX)/include"' >> $@
	echo done $@
../lib/WHERE.SLEPc-complex:
	test -e $(DIR_INSTALL_COMPLEX)/include/slepc.h
	-mkdir ../lib
	echo 'slepccomplex LD -Wl,-rpath,"$(DIR_INSTALL_COMPLEX)/lib" -L"$(DIR_INSTALL_COMPLEX)/lib" -lslepc' > $@
	echo 'slepccomplex INCLUDE -I"$(DIR_INSTALL_COMPLEX)/include"' >> $@
	echo done $@

WHERE-all:Makefile WHERE WHERE-complex
	echo >$@
	test -z '$(SCALAPACK_LIB)' || echo scalapack LD $(SCALAPACK_LIB) >>$@
	test -z '$(SCALAPACK_INCLUDE)' || echo scalapack INCLUDE -I$(SCALAPACK_INCLUDE) >>$@
	test -z '$(METIS_LIB)' || echo metis LD $(METIS_LIB) >>$@
	test -z '$(METIS_INCLUDE)' || echo metis INCLUDE -I$(METIS_INCLUDE) >>$@
	test -z '$(MUMPS_LIB)' || echo mumps LD $(MUMPS_LIB) >>$@

=== 3rdparty/mshmet/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

all-local: mshmet

include ff-flags

# Downloading and compiling mshmet
# -------------------------------
# 
DIRPKG= ../pkg
SRCDIR= ./mshmet$(mshmet_VERSION)
#-$(mshmet_VERSION)
PACKAGE=$(DIRPKG)/mshmet$(mshmet_VERSION).tgz
SERVER=http://www.ann.jussieu.fr/~frey/ftp/archives/
INSTALL=../..
mshmet_VERSION=.2012.04.25
FAIRE=$(SRCDIR)/FAIRE

# ---------------------- 
#     mshmetlib

MSHMET_DIR = $(abs_top_builddir)/3rdparty/mshmet/mshmet$(mshmet_VERSION)
MSHMET_SRCDIRNOLIB = $(MSHMET_DIR)/sources
MSHMET_SRCDIR = $(MSHMET_DIR)/sourceslib
MSHMET_OBJDIR = $(MSHMET_DIR)/objects

mshmet: $(FAIRE) 

$(FAIRE):$(SRCDIR)/FAIT
	$(MAKE) WHERE $(SRCDIR)/$(INSTALL)  
	touch $(FAIRE)

$(SRCDIR)/FAIT:$(SRCDIR)/tag-tar
	cd $(MSHMET_DIR); $(MAKE)
	touch $(SRCDIR)/FAIT

# FFCS - libMesh is also required by yams, so we move all the rules to [[file:../../../Makefile.am]]
install:$(SRCDIR)/FAIT
	cp $(MSHMET_SRCDIR)/mshmetlib.h  $(SRCDIR)/$(INSTALL)/include/mshmetlib.h
	cp $(MSHMET_OBJDIR)/libmshmet.a  $(SRCDIR)/$(INSTALL)/lib/libmshmet.a

# FFCS - simplify makefile structure for automatic rebuilds
WHERE:install
	echo mshmet  LD -L@DIR@/lib -lmshmet  >$(SRCDIR)/$(INSTALL)/lib/WHERE.mshmet
	echo mshmet INCLUDE -I@DIR@/include>> $(SRCDIR)/$(INSTALL)/lib/WHERE.mshmet


$(SRCDIR)/tag-tar: $(PACKAGE) mshmetlib-internal.h mshmetlib.c mshmetlib.h 
	-mkdir mshmet$(mshmet_VERSION)
	cd mshmet$(mshmet_VERSION); tar xzf ../$(PACKAGE)
	-mkdir $(MSHMET_SRCDIR)
	cp $(MSHMET_SRCDIRNOLIB)/*.c $(MSHMET_SRCDIRNOLIB)/*.h $(MSHMET_SRCDIR)
	cp $(MSHMET_SRCDIRNOLIB)/compil.date $(MSHMET_SRCDIR)
	cp mshmetlib-internal.h mshmetlib.c mshmetlib.h $(MSHMET_SRCDIR)/
	cp ../../src/libMesh/chrono.h $(MSHMET_SRCDIR)
	rm $(MSHMET_SRCDIR)/mshmet.c
	rm $(MSHMET_SRCDIR)/chrono.c
	cp ../../src/libMesh/eigenv.c $(MSHMET_SRCDIR)
	cp Makefile-mshmet.inc $(MSHMET_DIR)/makefile
	cd $(MSHMET_SRCDIR); patch -p2 < ../../mshmet.2011.03.06.patch
#
#	Patch for i586 developed by John Hunt (14/2/13)
#
	cd $(MSHMET_SRCDIR); patch -p2 < ../../mshmet.2012.04.25_i586.patch
	touch $(SRCDIR)/tag-tar

$(PACKAGE):
	../getall -o mshmet -a

clean:
	-rm ff-flags
#	FFCS - make sure that all directories are cleaned. Thisis especially important under Windows because there is no
#	compilation dependencies control there (see
#	[[file:c:/cygwin/home/alh/ffcs/dist/configure.ac::dependency_tracking]])
	-rm -rf mshmet.????.??.??
	-rm FAIT $(FAIRE) 

ff-flags: ../Makefile 
	grep 'abs_top_builddir *=' ../Makefile >> ff-flags
	grep 'CC *=' ../Makefile >> ff-flags
	grep 'CFLAGS *=' ../Makefile >> ff-flags
	grep 'LDFLAGS *=' ../Makefile >> ff-flags
	grep 'AR *=' ../Makefile >> ff-flags
	grep 'ARFLAGS *=' ../Makefile >> ff-flags
	grep 'RANLIB *=' ../Makefile >> ff-flags
	grep 'WGET *=' ../Makefile >> ff-flags
	grep 'mshmet_VERSION *=' ./Makefile >> ff-flags


.PHONY: $(SRCDIR)/$(INSTALL)

=== 3rdparty/parmmg/Makefile ===
# Downloading and compiling extra libraries
# -----------------------------------------

all-local: parmmg

include ff-flags

# Downloading and compiling parmmg
# -------------------------------
#
DIRPKG= ../pkg
SRCDIR= .
PACKAGE=$(DIRPKG)/parmmg.zip
INSTALL=.
parmmg_VERSION=

parmmg:WHERE.done

ifeq ($(WIN32DLLTARGET),)
CMAKE_GUESS := 
else
CMAKE_GUESS := -DMPI_GUESS_LIBRARY_NAME=MSMPI -G "MSYS Makefiles"
endif

FAIT.done:tag-tar
	-mkdir build
	cd build && cmake ../parmmg-sources \
	-DCMAKE_C_COMPILER=$(CC) \
	-DCMAKE_C_FLAGS="$(CFLAGS) -fPIC" \
	-DCMAKE_CXX_COMPILER="$(CXX)" \
	-DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CXX11FLAGS) -fPIC" \
	-DCMAKE_Fortran_COMPILER="$(FC)" \
	-DMPI_C_COMPILER="$(MPICC)" \
	-DMPI_CXX_COMPILER="$(MPICXX)" \
	-DMPI_Fortran_COMPILER="$(MPIFC)" \
	-DMPIEXEC_EXECUTABLE="$(MPIRUN)" \
	-DDOWNLOAD_MMG=OFF \
	-DDOWNLOAD_METIS=OFF \
	-DMMG_DIR=../../mmg/mmg-sources \
	-DMMG_BUILDDIR=../../mmg/build \
	-DSCOTCH_DIR=$(scotch_dir) \
	-DMETIS_DIR=$(metis_dir) -DUSE_VTK=OFF \
	-DCMAKE_BUILD_TYPE=Release $(CMAKE_GUESS) && $(MAKE)
	touch FAIT.done

install.done:FAIT.done
	cp -r build/include/parmmg ../include/parmmg
	cp build/lib/libparmmg.a ../lib
	touch $@
clean::
	-rm install.done FAIT.done

parmmg:$(PACKAGE)

install:install.done WHERE.done

WHERE.done: install.done
	echo parmmg LD -L@DIR@/lib -lparmmg >../lib/WHERE.parmmg ;
	echo parmmg INCLUDE -I@DIR@/include/>> ../lib/WHERE.parmmg ;
	echo build WHERE ./lib/WHERE.parmmg ;
	touch $@
clean::
	-rm WHERE.done

FAIRE: FAIT.done install.done

tag-tar: $(PACKAGE)
	-rm -rf ParMmg-* parmmg-sources
	unzip -q $(PACKAGE) && mv ParMmg-* parmmg-sources
	touch tag-tar

$(PACKAGE): FORCE
	../getall -o parmmg -a

FORCE:

clean::
	-rm ff-flags
	-rm FAIT* 
	-rm -rf ParMmg-* parmmg-sources build
	-rm flags-* tag-tar*
	-rm -rf ../include/parmmg
	-rm ../lib/libparmmg.a

ff-flags: ../Makefile Makefile ../getall
	../getall -o parmmg -a
	-cp -f ff-flags ff-flags.old
	grep 'abs_top_builddir *=' ../Makefile > ff-flags
	grep 'CC *=' ../Makefile >> ff-flags
	grep 'FC *=' ../Makefile >> ff-flags
	grep 'CFLAGS *=' ../Makefile >> ff-flags
	grep 'CXX *=' ../Makefile >> ff-flags
	grep 'CXXFLAGS *=' ../Makefile >> ff-flags
	grep 'CXX11FLAGS *=' ../Makefile >> ff-flags
	grep 'LDFLAGS *=' ../Makefile >> ff-flags
	grep 'AR *=' ../Makefile >> ff-flags
	grep 'ARFLAGS *=' ../Makefile >> ff-flags
	grep 'RANLIB *=' ../Makefile >> ff-flags
	grep 'WGET *=' ../Makefile >> ff-flags
	grep 'STD_LIBS *=' ../Makefile >> ff-flags
	grep 'CNOFLAGS *=' ../Makefile >> ff-flags
	grep 'FF_prefix_petsc_real *=' ../Makefile >> ff-flags
	grep 'MPICC *=' ../Makefile >> ff-flags
	grep 'MPICXX *=' ../Makefile >> ff-flags
	grep 'MPIFC *=' ../Makefile >> ff-flags
	grep 'MPIRUN *=' ../Makefile >> ff-flags
	grep 'WIN32DLLTARGET *=' ../Makefile >> ff-flags
	-awk '/^scotch LD /&&/petsc/ {print "scotch_dir=$$(FF_prefix_petsc_real)" }' ../../plugin/seq/WHERE_LIBRARY-config >> ff-flags
	-awk '/^scotch LD /{print "scotch_dir=../../../3rdparty/" }' ../lib/WHERE.scotch >> ff-flags
	-awk '/^metis LD /&&/petsc/ {print "metis_dir=$$(FF_prefix_petsc_real)" }' ../../plugin/seq/WHERE_LIBRARY-config >> ff-flags
	-awk '/^metis LD /{print "metis_dir=../../../3rdparty/" }' ../lib/WHERE.metis >> ff-flags
	../../bin/ff-md5 $(PACKAGE) >> ff-flags	
	if diff -q ff-flags ff-flags.old ; then echo No Modif skip compile of parmmg ; else touch -c tag-tar; fi
	
.PHONY:$(SRCDIR)/$(INSTALL)

=== examples/3d/CMakeLists.txt ===
FILE(GLOB EDP_FILES *.edp)

IF(NOT FREEFEM_MSH3_INSTALLED)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/3d/3d-Leman.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/EqPoisson.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/Lac.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/Laplace3d.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/LaplaceRT-3d.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/NSI3d-carac.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/NSI3d.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/Poisson-cube-ballon.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/Sphere-Isocahedron.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/Stokes.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/TruncLac.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/bottle.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/cone.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/convect-3d.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/cube-period.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/cylinder.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/cylinder-3d.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/extract-boundary3d.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/periodic-3d.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/pyramide.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/refinesphere.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/regtests.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/sphere2.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/sphere6.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/tetgencube.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/tetgenholeregion.edp
                             )
ENDIF(NOT FREEFEM_MSH3_INSTALLED)


IF(NOT FF_PLUGIN_TETGEN)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_CURRENT_SOURCE_DIR}/Poisson3d.edp)
ENDIF(NOT FF_PLUGIN_TETGEN)


IF(NOT FREEFEM_MEDIT_INSTALLED)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/3d/beam-3d.edp)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/3d/intlevelset3d.edp)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/3d/meditddm.edp)
ENDIF(NOT FREEFEM_MEDIT_INSTALLED)


# remove tests depending on freeyams library if not installed
IF(NOT FREEFEM_FREEYAMS_INSTALLED)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/3d/Laplace-Adapt.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/Period-Poisson-cube-ballon.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/sphereincube.edp)
ENDIF(NOT FREEFEM_FREEYAMS_INSTALLED)

# remove tests depending on metis library if not installed
IF(NOT FREEFEM_METIS_INSTALLED)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/3d/schwarz-nm-3d.edp)
ENDIF(NOT FREEFEM_METIS_INSTALLED)

# remove tests depending on mshmet library if not installed
IF(NOT FREEFEM_MMG3D_INSTALLED)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/3d/fallingspheres.edp)
ENDIF(NOT FREEFEM_MMG3D_INSTALLED)

# remove tests depending on mshmet library if not installed
IF(NOT FREEFEM_MSHMET_INSTALLED)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/3d/schwarz-nm-3d.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/Laplace-Adapt-3d.edp
                             ${CMAKE_SOURCE_DIR}/examples/3d/Laplace-Adapt-aniso-3d.edp)
ENDIF(NOT FREEFEM_MSHMET_INSTALLED)


# tests with without dependencies
FOREACH(EDP_FILE ${EDP_FILES})
  GET_FILENAME_COMPONENT(FILENAME ${EDP_FILE} NAME_WE)
  ADD_TEST(NAME ${FILENAME} COMMAND "${CMAKE_BINARY_DIR}/src/FreeFem++" ${EDP_FILE}
                            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/examples/3d)
ENDFOREACH(EDP_FILE)

=== examples/3dSurf/CMakeLists.txt ===
FILE(GLOB EDP_FILES *.edp)

IF(NOT FREEFEM_MSH3_INSTALLED)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/3dSurf/)
ENDIF(NOT FREEFEM_MSH3_INSTALLED)


IF(NOT FF_PLUGIN_TETGEN)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_CURRENT_SOURCE_DIR}/HeatTorus.edp)
ENDIF(NOT FF_PLUGIN_TETGEN)


IF(NOT FREEFEM_MEDIT_INSTALLED)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/3dSurf/LaplacianSurf.edp)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/3dSurf/buildMeshSfromMesh3.edp)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/3dSurf/operatorsOnMeshS.edp)
ENDIF(NOT FREEFEM_MEDIT_INSTALLED)


# remove tests depending on freeyams library if not installed
IF(NOT FREEFEM_FREEYAMS_INSTALLED)
  LIST(REMOVE_ITEM EDP_FILES ${CMAKE_SOURCE_DIR}/examples/3dSurf/HeatTorus.edp)
ENDIF(NOT FREEFEM_FREEYAMS_INSTALLED)



# tests with without dependencies
FOREACH(EDP_FILE ${EDP_FILES})
  GET_FILENAME_COMPONENT(FILENAME ${EDP_FILE} NAME_WE)
  ADD_TEST(NAME ${FILENAME} COMMAND "${CMAKE_BINARY_DIR}/src/FreeFem++" ${EDP_FILE}
                            WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/examples/3dSurf)
ENDFOREACH(EDP_FILE)

=== src/bamglib/CMakeLists.txt ===
FILE(GLOB_RECURSE CPPFILES *.cpp)
LIST(REMOVE_ITEM CPPFILES ${CMAKE_SOURCE_DIR}/src/bamglib/Meshgibbs.cpp)
ADD_LIBRARY(bamglib ${CPPFILES})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src/fflib)

=== src/libMesh/CMakeLists.txt ===
FILE(GLOB_RECURSE CFILES *.c)

LIST(REMOVE_ITEM CFILES ${CMAKE_SOURCE_DIR}/src/libMesh/test_sol.c
                        ${CMAKE_SOURCE_DIR}/src/libMesh/test_libmesh5.c)

ADD_LIBRARY(libMesh ${CFILES})

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src/femlib ${CMAKE_SOURCE_DIR}/src/libMesh)

SET_TARGET_PROPERTIES(libMesh PROPERTIES PREFIX "")

=== debian/changelog ===
freefem++ (4.11+dfsg1-3) unstable; urgency=high

  * Add allow-stderr restriction for build-and-run-lib (Closes: #1033702)

 -- Francois Mazen <francois@mzf.fr>  Sat, 08 Apr 2023 15:19:26 +0200

freefem++ (4.11+dfsg1-2) unstable; urgency=medium

  * Limit autopkgtest architectures to allow testing migration (Closes:
    #992924)

 -- Francois Mazen <francois@mzf.fr>  Sun, 17 Apr 2022 14:09:49 +0200

freefem++ (4.11+dfsg1-1) unstable; urgency=medium

  * New upstream version
  * Update debian/copyright for automatic repack
  * Bump standard version to 4.6.0.1

 -- Francois Mazen <francois@mzf.fr>  Sat, 09 Apr 2022 21:11:07 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: freefem++
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Christophe Trophime <christophe.trophime@lncmi.cnrs.fr>,
            Dimitrios Eftaxiopoulos <eftaxi12@otenet.gr>,
            Francois Mazen <francois@mzf.fr>
@@ -52,7 +51,7 @@
 # libparms2-dev, libitsol-dev,
 # libhips-dev, libpastix-dev,
 # libsuperlu-dist-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0.1
 Vcs-Browser: https://salsa.debian.org/science-team/freefempp
 Vcs-Git: https://salsa.debian.org/science-team/freefempp.git
 Homepage: http://www.freefem.org/ff++/

=== debian/tests/control ===
--- 
+++ 
@@ -7,3 +7,5 @@
 
 Tests: build-and-run-lib
 Depends: libfreefem++-dev, freefem++, build-essential
+Restrictions: allow-stderr
+Architecture: amd64, armhf, i386
